<template>
  <div class="account-resource" ref="resource">
    <template v-if="isOffer && order.status === 'NEW'">
      <div class="account-resource__title">
        Транспорт и водитель
      </div>
    </template>
    <template v-else>
      <div class="account-resource__title">
        Назначьте транспорт и водителя
      </div>
      <ObSelect
          display-exp="serviceTypeTitle"
          value-exp="serviceTypeUuid"
          :value="currentServiceTypeValue"
          :items="currentServiceTypeList()"
          :disabled="flag || buttonAcceptResource"
          @selected="onChangeServiceType"
      />
    </template>
    <div
      v-for="{ superclass, uuid } in requiredResourcesList"
      :key="uuid"
      class="account-resource__row"
    >
      <OrderResourceSelect
        :order-uuid="order.suborderUuid"
        :is-disabled="flag || buttonAcceptResource"
        :value="selectedData[superclass]"
        :action-icon="true"
        :resource-superclass="superclass"
        @input="setResource({ superclass, data: $event })"
        @on-select="setResource({ superclass, data: $event })"
      />
    </div>
  </div>
</template>

<script>
  import OrderResourceSelect from '@/components/Order/resourceSelectors/orderResourceSelect'
  import { mapGetters, mapActions, mapMutations } from 'vuex'
  import STEPS from '@/constants/steps.js'
  import ObSelect from 'common-components/src/obComponents/obSelect'
  import { getServiceIcon } from "@/constants/order"

  export default {
    name: 'OrderCarrierResourceSelect',
    components: {
      OrderResourceSelect,
      ObSelect
    },
    data () {
      return {
        STEP: STEPS
      }
    },
    mounted () {
      if (this.order.orderStatus === this.STEP.BOOKED) {
        this.$refs.resource.scrollIntoView()
      }
    },
    computed: {
      ...mapGetters({
        order: 'account/order',
        buttonAcceptResource: 'account/buttonAcceptResource',
        requiredResources: 'account/requiredResources',
        requiredResourcesValues: 'account/requiredResourcesValues',
        contractorUuid: 'user/participantUuid',
        isOffer: 'account/isOffer'
      }),
      isMainOrder () {
        return this.contractorUuid === this.order?.contractorUuid
      },
      flag () {
        return !this.isMainOrder || [this.STEP.ALLOCATED, this.STEP.CONTRACTED, this.STEP.IN_PROCESS].includes(this.order.orderStatus) || !this.order.isEditable
      },
      selectedData () {
        let result = {}

        this.requiredResourcesList.forEach(({ superclass }) => {
          result[superclass] = this.order.resources?.find(key => key.superclass === superclass)
        })

        return result
      },
      currentServiceType () {
        return this.requiredResourcesValues?.[this.order.uuid] || {}
      },
      currentServiceTypeValue () {
        return this.currentServiceType.serviceTypeUuid || ''
      },
      requiredResourcesList () {
        if (this.isOffer && this.order.status === 'NEW') {
          return this.order.resources || []
        } else {
          return this.currentServiceType?.requiredResources || []
        }
      }
    },
    methods: {
      ...mapActions({
        setResource: 'account/setResource'
      }),
      ...mapMutations({
        setRequiredResourcesValues: 'account/setRequiredResourcesValues'
      }),
      currentServiceTypeList () {
        return (this.requiredResources?.[this.order.uuid] || []).filter((service) => {
          return (this.order.resources || []).every(resource => {
            return service.requiredResources.find(requiredResource => {
              return requiredResource.superclass === resource.superclass
            })
          })
        }).map(item => {
          return {
            ...item,
            html: `<div class="icon-service-type">${getServiceIcon( { uuid: item.serviceTypeUuid }).icon}</div>`
          }
        })
      },
      onChangeServiceType (data) {
        this.setRequiredResourcesValues({ uuid: this.order.uuid, data })
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/variables";
  .account-resource {
    &__title {
      margin-bottom: 10px;
      font-weight: bold;
      font-size: 16px;
      line-height: 24px;
      letter-spacing: 0.4px;
      color: $color-text-base;
    }

    &__row {
      margin-top: 20px;
    }

    &::v-deep {
      .ob-selector__title {
        justify-content: center;
      }
      .ob-selector {
        width: auto;
      }
    }
  }

</style>

<style lang="scss">
.icon-service-type {
  display: block;
  width: 55px;
  height: 18px;
  text-align: left;
  img {
    height: 18px!important;
    width: auto!important;
  }
  .ob-selector__value & {
    width: auto;
  }
}
</style>
